package gg.malloc.defense;

import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDeathEvent;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.entity.PlayerQuitEvent;
import org.bukkit.event.entity.EntityCombustEvent;
import org.bukkit.entity.Player;

public class GameEventHandler implements Listener {
  Plugin m_plugin;

  public GameEventHandler(Plugin plugin) {
    m_plugin = plugin;
  }

  @EventHandler
  public void onEntityDeath(EntityDeathEvent evt) {
    GameRunner runner = m_plugin.getRunnerForWorld(evt.getEntity().getLocation().getWorld());
    runner.handleEntityDeath(evt.getEntity());
  }

  @EventHandler
  public void onPlayerQuit(PlayerQuitEvent evt) {
    GameRunner runner = m_plugin.getRunnerForWorld(evt.getPlayer().getLocation().getWorld());
    runner.removePlayer(evt.getEntity());
  }

  @EventHandler
  public void onEntityCombust(EntityCombustEvent evt) {
    evt.setCancelled(true);
  }

  @EventHandler
  public void onEntityDamage(EntityDamageEvent evt) {
    if (evt.getEntity() instanceof Player) {
      Player player = (Player)evt.getEntity();
      if (player.getHealth() - evt.getFinalDamage() <= 0) {
        GameRunner runner = m_plugin.getRunnerForWorld(evt.getEntity().getLocation().getWorld());
        evt.setCancelled(true);
        runner.handlePlayerDeath(player);
      }
    }
  }
}
