package gg.malloc.defense;

import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.World;

public class SetStageCommand implements CommandExecutor {
  Plugin m_plugin;

  public SetStageCommand(Plugin plugin) {
    m_plugin = plugin;
  }

  @Override
  public boolean onCommand(CommandSender sender, Command command, String s, String[] args) {
    World world = m_plugin.getServer().getWorld(args[1]);
    GameRunner runner = m_plugin.getRunnerForWorld(world);
    String stateName = args[0].toLowerCase();
    boolean ret = false;
    if (stateName.equals("idle")) {
      ret = runner.requestTransition(GameRunner.State.Idle);
    } else if (stateName.equals("warmup")) {
      ret = runner.requestTransition(GameRunner.State.Warmup);
    } else if (stateName.equals("playing")) {
      ret = runner.requestTransition(GameRunner.State.Playing);
    } else if (stateName.equals("gameover")) {
      ret = runner.requestTransition(GameRunner.State.GameOver);
    } else {
      sender.sendMessage("Unknown state " + stateName);
      return false;
    }
    if (!ret) {
      sender.sendMessage("Could not set state to " + stateName);
    }
    return ret;
  }
}
